Subject: Re: bug#33755: error: execlp: No such file or directory from guix environment

From: Timothy Sample <[email-masked]>
Date: Sun, 16 Dec 2018 23:41:38 -0500

Hi Ludo,

Ludovic Courtès <[email-masked]> writes:

> Hello comrades!
>
> Timothy Sample <[email-masked]> skribis:
>
>> [...]
>>
>> From aedc745a3f9765ae00dc61a59fa53d22a458551b Mon Sep 17 00:00:00 2001
>> From: Timothy Sample <[email-masked]>
>> Date: Sat, 15 Dec 2018 23:17:46 -0500
>> Subject: [PATCH] environment: Print command name on execlp error.
>>
>> Fixes <https://bugs.gnu.org/33755>.
>>
>> * guix/scripts/environment.scm (launch-environment): When execlp fails,
>> include the command name in the error message.
>
> Another option would be to do:
>
>   (set! execl
>     (error-reporting-wrapper …))
>
> in (guix ui), as done for a few other procedures that have the same
> issue.
>
> WDYT?

Aha!  I didn’t know about “error-reporting-wrapper”.  I think this makes
sense.  It fixes the same issue in the container script, too.  I’ve
attached an updated patch.

I had to modify “error-reporting-wrapper” to deal with the fact that
“execlp” takes a variable number of arguments.  I tested it and it works
for the old use-case as well as the new.  On whether or not it works
stylistically, I defer to you.

-- Tim

>From 428b80973026909c915e1f33d4509e82f66355e3 Mon Sep 17 00:00:00 2001
From: Timothy Sample <[email-masked]>
Date: Sun, 16 Dec 2018 23:12:13 -0500
Subject: [PATCH] ui: Report file names in 'system-error' exceptions from
 'execlp'.

Fixes <https://bugs.gnu.org/33755>.

* guix/ui.scm (apply-formals): New macro.
(execlp): New error-reporting wrapper.
---
 guix/ui.scm | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

diff --git a/guix/ui.scm b/guix/ui.scm
index 60636edac..148c18103 100644
--- a/guix/ui.scm
+++ b/guix/ui.scm
@@ -502,14 +502,19 @@ General help using GNU software: <http://www.gnu.org/gethelp/>"))
            (list (strerror (car errno)) file)
            (list errno))))
 
-(define-syntax-rule (error-reporting-wrapper proc (args ...) file)
+(define-syntax apply-formals
+  (syntax-rules ()
+    ((_ proc (args ...)) (proc args ...))
+    ((_ proc (arg1 args ... . rest)) (apply proc arg1 args ... rest))))
+
+(define-syntax-rule (error-reporting-wrapper proc formals file)
   "Wrap PROC such that its 'system-error' exceptions are augmented to mention
 FILE."
   (let ((real-proc (@ (guile) proc)))
-    (lambda (args ...)
+    (lambda formals
       (catch 'system-error
         (lambda ()
-          (real-proc args ...))
+          (apply-formals real-proc formals))
         (augmented-system-error-handler file)))))
 
 (set! symlink
@@ -528,6 +533,8 @@ FILE."
 (set! delete-file
   (error-reporting-wrapper delete-file (file) file))
 
+(set! execlp
+  (error-reporting-wrapper execlp (filename . args) filename))
 
 (define (make-regexp* regexp . flags)
   "Like 'make-regexp' but error out if REGEXP is invalid, reporting the error
-- 
2.20.0